/*
** Support
**
**	A module containing miscellanous support functions to be
**	used from application programs.
**
** Copyright 1992, 1993 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author may be contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <stdio.h>
#include <string.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xew/Basic.h>
#include <X11/Xew/Support.h>

/*
** XeFindContentFormat
**	An utility function that tries to guess the content format
**	and returns the XeContentFormat type guessed. A failure to
**	guess or any error results a value XeContentFormat_UNKNOWN
**	to be returned.
**
**	The current implementation only works for Raster Images.
**	(Enchance this later --msa)
**
**	This code is based from the similar stuff in 'xv' program.
*/
XeContentFormat XeFindContentFormat(name)
char *name;
    {
	unsigned char magicno[8];    /* first 8 bytes of file */
	FILE *f = fopen(name,"rb");

	if (f == NULL)
		return XeContentFormat_UNKNOWN;

	fread(magicno,8,1,f);
	fclose(f);
	if (strncmp((char *)magicno, "GIF87a", 6) == 0 ||
	    strncmp((char *)magicno, "GIF89a", 6) == 0)
		return XeContentFormat_GIF;

	if (magicno[0] == 0xff && magicno[1] == 0xd8 &&  magicno[2] == 0xff)
		return XeContentFormat_JPEG;

	if ((magicno[0]=='M' && magicno[1]=='M') ||
	    (magicno[0]=='I' && magicno[1]=='I'))
		return XeContentFormat_TIFF;

	if (strncmp((char *)magicno, ".snd", 4) == 0)
		return XeContentFormat_AUDIO;

	return XeContentFormat_UNKNOWN;
    }
