#ifndef _XewTextEd_h
#define _XewTextEd_h
/*
** Copyright 1993 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author maybe contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/

#include <X11/Xmu/Converters.h>
#include <X11/Xew/Basic.h>
#include <X11/Xew/Text.h>

	
/* New fields */
#define XtNallowEdit "allowEdit"
#define XtCAllowEdit "AllowEdit"
#define XtNcursorPosition "cursorPosition"
#define XtCCursorPosition "CursorPosition"

/*

  Resources:

  Testing the reources
.TS
tab(@) ;
lB1 lB1 lB1 lB.
Name@Class@Type@Default
.T&
lB1 l1 l1 l.
alignment@XeAlignment@XeAlignment@XeStartAligned
allowEdit@AllowEdit@Boolean@True
background@Background@Pixel@XtDefaultBackground
border@BorderColor@Pixel@XtDefaultForeground
borderWidth@BorderWidth@Dimension@1
contentFile@ContentFile@String@NULL
contentLength@ContentLength@long@Computed from content
contentOffset@ContentOffset@long@0
contentStream@ContentStream@FILE *@NULL
contentString@ContentString@Pointer@NULL
cursor@Cursor@Cursor@None
cursorPosition@CursorPosition@long@0
destroyCallback@Callback@Pointer@NULL
exportFormat@ExportFormat@XeTextExport@XeTextExport_ODIF
firstLineOffset@Offset@int@0
fonts@XeFonts@XeFont *@NULL
format@Format@Boolean@False
graphicRendition@Rendition@String@NULL
height@Height@Dimension@0
indentation@Offset@Dimension@0
initialState@Sequence@String@NULL
itemization@Itemization@XeItemization *@NULL
kerningOffset@KerningOffset@Dimension *@NULL
lineLayoutTable@LineLayoutTable@XeTabStop *@NULL
lineSpacing@LineSpacing@Dimension@Computed from font
mappedWhenManaged@MappedWhenManaged@Boolean@True
proportional@Proportional@Boolean@False
width@Width@Dimension@0
x@Position@Position@0
y@Position@Position@0
.TE

cursorposition

resource defines the current virtual cursor position. The value can be read and set.
The virtual position defines the character offset from the beginning of the
content. The position in front of the first character is 0. In addition to
characters, the virtual position count hard lineends, shifts in vertical
position (partial line up and down) as one position.
*/
extern WidgetClass xeTextEdWidgetClass;

typedef struct _XeTextEdClassRec *XeTextEdWidgetClass;
typedef struct _XeTextEdRec      *XeTextEdWidget;

_XFUNCPROTOBEGIN
/*
** XeTextSaveAsFile
**	Save the current content of the Text widget into a file. The format
**	of the exported file is determined from by the 'exportFormat'
**	resource (text.export_format). Returns True, if save succeeds
**	and False otherwise.
*/
Boolean XeTextSaveAsFile
	(
#if NeedFunctionPrototypes
	 Widget, String
#endif
	 );

/*
** XeTextGetString
**	Save the current content of the Text widget into a String. The format
**	of the exported data is determined from by the 'exportFormat'
**	resource (text.export_format).
**
**	Returns a pointer to the allocated String. The actual length of the
**	string is returned into long integer 'length' (if non-NULL).
**	Application must release the returned string with XtFree.
*/
String XeTextGetString
	(
#if NeedFunctionPrototypes
	 Widget,	/* XeTextEdWidget */
	 long *		/* Address of the long variable that will contain the
			   length of the returned String in bytes */
#endif
	 );
/*
** XeTextReplace
**	Replace content of the text widget between positions (start, end)
**	with new the content. This can be used inserting text by having
**	start == end.
**
**	Insert position will be at the end of the inserted text.
**
*/
void XeTextReplace
	(
#if NeedFunctionPrototypes
	 Widget,	/* XeTextEdWidget */
	 long,		/* Start position */
	 long,		/* End position */
	 char *,	/* Text to replace with */
	 long		/* Length of the text to replace with */
#endif
	 );

/*
** XeTextGetSelectionPosition
**	Return currently selected text range. If the returned start and
**	end are equal, no selection is currently active. The returned
**	start will alway be less or equal to the returned end.
*/
void XeTextGetSelectionPosition
	(
#if NeedFunctionPrototypes
	 Widget,	/* XeTextEdWidget */
	 long *,	/* Address for the returned start position */
	 long *		/* Address for the returned end position */
#endif
	 );
_XFUNCPROTOEND
#endif
