#ifndef TextImport_h
#define TextImport_h
/*
** Copyright 1992, 1993 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author maybe contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/
#include <X11/Xew/TextP.h>

_XFUNCPROTOBEGIN

XeTextInsertContext XeTextBeginContent
	(
#if NeedFunctionPrototypes
	 XeTextWidget
#endif
	 );

XeTextInsertContext XeTextInsertContent
	(
#if NeedFunctionPrototypes
	 XeTextWidget,	/* Text Widget */
	 Snip *,	/* Insert Point: Snip */
	 int		/* Insert Point: Offset within Snip */
#endif
	 );

Snip *XeTextDeleteContent
	(
#if NeedFunctionPrototypes
	 XeTextInsertContext,	/* Context Pointer */
	 long			/* Characters to Delete */
#endif
	 );

Snip *XeTextEndContent
	(
#if NeedFunctionPrototypes
	 XeTextInsertContext,	/* Context Pointer */
	 XRectangle *		/* Expose area */
#endif
	 );
Snip *XeTextInsertPoint
	(
#if NeedFunctionPrototypes
	 XeTextInsertContext,	/* Context Pointer */
	 XRectangle *		/* Expose area */
#endif
	 );
/*
** Feeding Character Content
*/
int XeTextFeedContent
	(
#if NeedFunctionPrototypes
	 XeTextInsertContext,	/* Context Pointer */
	 char *,		/* Pointer to content byte stream */
	 long			/* Number of bytes to feed from pointer */
#endif
	 );

_XFUNCPROTOEND


/*
** ISO 2022 Charset changling support (for TextExport.h)
** =====================================================
**	These definitions don't seem to belong to here and
**	are provided only temporarily, until a proper
**	XeTextCharset module gets designed and constructed.
*/

/*
** XeCharsetDesignation
**	identifies a registered characterset uniquely by listing
**	the following components (these are sufficient for the
**	currently supported set):
*/
#define XeCharset_F	0xFF	/* Final character Mask */
#define XeCharset_96	0x100	/* 96 characterset */
#define XeCharset_M	0x200	/* Multibyte characterset */

typedef unsigned short XeCharsetDesignation;
/*
** XeCharsetIdentifier
**	identifies internally the character set used in the
**	SnipData. (Currently this is just a plain pointer to a
**	constant character string representing X11 font
**	encoding. [ This will change at some point --msa]
*/
typedef char * XeCharsetIdentifier;

_XFUNCPROTOBEGIN
/*
** XeTextCharsetSelect
**	returns a pointer to a ZERO terminated list of character
**	sets (XeCharsetDesignation) which describe the ISO 2022
**	state that matches the codes used in data. The order of
**	entries is significant:
**
**		0	GL	G0
**		1	GR	G1
*/
XeCharsetDesignation *XeTextCharsetSelect
	(
#if NeedFunctionPrototypes
	 XeCharsetIdentifier	/* Internal Charset Identifier */
#endif
	 );
/*
** XeTextCharsetDefault
**	returns unique charset idenfier for the default character
**	set.
*/
XeCharsetIdentifier XeTextCharsetDefault
	(
#if NeedFunctionPrototypes
	 void
#endif
	 );
_XFUNCPROTOEND

#endif

