#ifndef _XewVideo_h
#define _XewVideo_h
/*
** Copyright 1992 by Markku Savela and
**	Technical Research Centre of Finland
**
** The author maybe contacted via:
**
**    Mail:	Markku Savela
**		Technical Research Centre of Finland
**		Telecommunications Laboratory
**		Otakaari 7 B, P.O. Box 34
**		SF-02151 ESPOO
**		Finland
**
**    Phone:	+358 0 456 6509
**    Email:	savela@tel.vtt.fi
*/


#include <X11/Xmu/Converters.h>

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	0
 bottomEdge          XeEdge             XeEdge *        NULL
 brightness          Brightness         int             0
 contentFile         ContentFile        String          NULL
 contentLength       ContentLength      long            0
 contentOffset       ContentOffset      long            0
 contentStream       ContentStream      FILE *          NULL
 contentString       ContentString      Pointer         NULL
 contrast            Contrast           int             0
 currentFrame        CurrentFrame       long            1
 cursor              Cursor             Cursor          None
 destroyCallback     Callback		Pointer		NULL
 firstFrame          FirstFrame         long            1
 height		     Height		Dimension	0
 lastFrame           LastFrame          long            0
 leftEdge            XeEdge             XeEdge *        NULL
 loop                Loop               Boolean         False
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 play                Play               XePlay          XePlay_FORWARD
 rate                Rate               long            1
 rightEdge           XeEdge             XeEdge *        NULL
 topEdge             XeEdge             XeEdge *        NULL
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

*/

/* New fields */
#define XtNcontrast "contrast"
#define XtCContrast "Contrast"
#define XtNbrightness "brightness"
#define XtCBrightness "Brightness"
#define XtNuseShm   "useShm"
#define XtCuseShm   "UseShm"

/* Class record constants */

extern WidgetClass xeVideoWidgetClass;

typedef struct _XeVideoClassRec *XeVideoWidgetClass;
typedef struct _XeVideoRec *XeVideoWidget;


#endif




