/*
** Very Simple Xew Widget Demonstration Program (R5 or later required).
** (Using porthhole and panner, logic copied from editres program :)
*/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Panner.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Porthole.h>
#include <X11/Xew/Basic.h>
#include <X11/Xew/Raster.h>
#include <X11/Xew/Text.h>
#include <X11/Xew/Audio.h>
#include <X11/Xew/Support.h>

static Widget lookingat = None;

static void Quit(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
    {
	XtDestroyApplicationContext(XtWidgetToApplicationContext(w));
	exit(0);
    }

/*
** Sample Notify skeleton..
*/
static void Notify(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
    {
	XeNotifyCallbackData *notify = (XeNotifyCallbackData *)call_data;
	int i;

	switch (notify->reason)
	    {
	    case XeCR_NOTIFY:
		/* Quickhack: just assume it's a button event! */
		printf("Notify(");
		for (i = 0; i < notify->num_params; i++)
			printf("%s%s", i==0?"":",", notify->params[i]);
		printf(") at (%d,%d)\n",
		       (int)notify->event->xbutton.x,
		       (int)notify->event->xbutton.y);
		break;
	    default:
		printf("UNKNOWN: XeRC=%d\n");
		break;
	    }
    }

void PortholeCallback(w, panner_ptr, report_ptr)
Widget w;
XtPointer panner_ptr, report_ptr;
    {
	Arg args[10];
	Cardinal n = 0;
	XawPannerReport *report = (XawPannerReport *)report_ptr;
	Widget panner = (Widget)panner_ptr;

	XtSetArg(args[n], XtNsliderX, report->slider_x); n++;
	XtSetArg(args[n], XtNsliderY, report->slider_y); n++;
	if (report->changed != (XawPRSliderX | XawPRSliderY))
	    {
		XtSetArg(args[n], XtNsliderWidth, report->slider_width); n++;
		XtSetArg(args[n], XtNsliderHeight, report->slider_height); n++;
		XtSetArg(args[n], XtNcanvasWidth, report->canvas_width); n++;
		XtSetArg(args[n], XtNcanvasHeight, report->canvas_height); n++;
	    }
	XtSetValues (panner, args, n);
    }

void PannerCallback(w, closure, report_ptr)
Widget w;
XtPointer closure, report_ptr;
    {
	Arg args[2];
	XawPannerReport *report = (XawPannerReport *)report_ptr;

	if (lookingat == None) 
		return;
	XtSetArg (args[0], XtNx, -report->slider_x);
	XtSetArg (args[1], XtNy, -report->slider_y);
	XtSetValues(lookingat, args, 2);
    }

main(argc, argv)
int argc; char *argv[];
    {
	XtAppContext demo_application;
	Widget root_widget, porthole, panner, pane, box, button;
	Arg args[10];
	int n;
	char *imagefile;
	XeContentFormat imagetype;

	root_widget = XtAppInitialize
		(&demo_application, "XewSimple", NULL,0, &argc, argv,
		 (String *)NULL, NULL, 0);
	n = 0;
	pane = XtCreateManagedWidget
		("pane", panedWidgetClass, root_widget, args, n);
				     
	n = 0;
	box = XtCreateManagedWidget
		("box", boxWidgetClass, pane, args, n);
	n = 0;
	button = XtCreateManagedWidget
		("quit", commandWidgetClass, box, args, n);
	XtAddCallback(button, XtNcallback, Quit, NULL);
	n = 0;
	panner = XtCreateManagedWidget
		("panner", pannerWidgetClass, box, args, n);
	n = 0;
	porthole = XtCreateManagedWidget
		("DemoPort", portholeWidgetClass, pane, args, n);
	XtAddCallback(porthole, XtNreportCallback,
		      PortholeCallback, (XtPointer)panner);
	XtAddCallback(panner, XtNreportCallback,
		      PannerCallback, (XtPointer)porthole);
	if (argc > 1)
		imagefile = argv[1];
	else
		imagefile = "Raster/Amick-2.jpg";
	imagetype = XeFindContentFormat(imagefile);
	n = 0;
	XtSetArg(args[n], XtNcontentFile, imagefile); ++n;
	XtSetArg(args[n], XtNcontentFormat, imagetype); ++n;
	if (imagetype == XeContentFormat_UNKNOWN)
	    {
		printf("Assuming Text content type\n");
		/*
		** Request proportional spacing, because we are not
		** specifying the lineSpacing.
		*/
		XtSetArg(args[n], XtNproportional, True); ++n;
		lookingat = XtCreateManagedWidget
			("DemoText", xeTextWidgetClass, porthole, args, n);
		
	    }
	else if (imagetype == XeContentFormat_AUDIO)
	    {
		XtSetArg(args[n], XtNplay, XePlay_FREEZE); ++n;
		lookingat = XtCreateManagedWidget
			("DemoAudio", xeAudioWidgetClass, porthole, args, n);
	    }
	else
	    {
		XtSetArg(args[n], XtNscaling, XeScaling_NONE); ++n;
		lookingat = XtCreateManagedWidget
			("DemoRaster", xeRasterWidgetClass, porthole, args, n);
	    }
	XtAddCallback(lookingat, XtNnotifyCallback, Notify, (XtPointer)NULL);
	XtRealizeWidget(root_widget);
	XtAppMainLoop(demo_application);
	return 0;
    }

